

//#include <windows.h>
#include "ccr.h"
//#include "Pplib95.h"
#include <iostream.h>
#include <conio.h>
//#include <fstream.h>
#include <stdio.h>


void Menu(char &option) {
//*********************************************************************//
//   Paints the menu screen and requests the menu option.              //
//                                                                     //
//   option - returned as the user selected option                     //
//*********************************************************************//

   
//  gotoxy(10,3);
//   textcolor(LIGHTBLUE);
  cout << "C C R   I N P U T / O U T P U T    M A I N T A I N E R\n\n\n";
//   textcolor(LIGHTGRAY);

   //   Initialize the picklist options

   cout << "\n";
   cout << "                 1 - INITIALIZE board settings (I/O)\n\n";
   cout << "                 2 - TOGGLE a turnout\n\n";
   cout << "                 3 - SET CHANNEL to ON\n";
   cout << "                 4 - SET CHANNEL to OFF\n";
   cout << "                 5 - GET CHANNEL value\n";
   cout << "                 6 - SET PORT value\n";
   cout << "                 7 - GET PORT value\n";
   cout << "                 8 - GET turnout POSITION\n\n\n\n";
   cout << "          0 - EXIT the system\n\n";

   cout << "          Enter an option: ";
   cin >> option;
} //Menu




//***************************************************************//
//                                                               //
//                 USER INTERFACED FUNCTIONS                     //
//                                                               //
//        These functions prompt the user for the input          //
//        parameters needed by the base functions.  They         //
//        also display significant messages to the user.         //
//                                                               //
//***************************************************************//

void userInitailize_Board()  {

   short a_val;
   short b_val;
   short cl_val;
   short ch_val;
   short reg_val;		        //value of the control reg. of the board
   short board_num; 		//number of board from 8255 to set
   short x;                       //working value
   short ok;                      //sucess flag

  
   cout << "\n\n   Please enter the board number to intitialize (1-9): ";
   cin >> board_num;

   //check for a valid board number
   if ((board_num < 1) || (board_num > 9))  {
      cout << "\n\n   Initailization Error!!!  Not a valid Board Number.";
//      Sleep(2000);
      return;
   }

   reg_val = Get_Port ((TO_output-1) + (board_num * 4));   //768,769...

   //1 = input, 0 = output
   //check CL
   cl_val = reg_val & 1;

   //check B
   x = reg_val >> 1;		//shift right one place
   b_val = x & 1;

   //check CH
   x = reg_val >> 3;		//shift right three places
   ch_val = x & 1;

   //check A
   x = reg_val >> 4;		//shift right four places
   a_val = x & 1;

   //display current port settings
   cout << "\n\n   CURRENT PORT SETTINGS   (Input = 1, Output = 0)\n\n";
   cout << "   Port A  ( 0-7 ): " << a_val << endl;
   cout << "   Port B  ( 8-15): " << b_val << endl;
   cout << "   Port CL (16-19): " << cl_val << endl;
   cout << "   Port CH (20-24): " << ch_val << endl;

   //prompt for new settings (1 or 0)
   cout << "\n   Please enter new port settings (1 or 0) for...\n\n";
   cout << "   Port A  ( 0-7 ): "; cin >> a_val;
   cout << "   Port B  ( 8-15): "; cin >> b_val;
   cout << "   Port CL (16-19): "; cin >> cl_val;
   cout << "   Port CH (20-24): "; cin >> ch_val;

   //set new port settings and verify results
   ok = Initialize_Board (board_num, a_val, b_val, cl_val, ch_val);

   if (ok == 1)  {
	cout << "\n   Initailization Complete.";
//	getch();
   }
   else  {
	cout << "\n   Initailization Error!!!";
//	getch();
   }
   return;
}

//***************************************************************//

void userSet_Chan_On()  {

   short chan_num;    //channel (0-7)
   short port_num;    //port number (768, 769,...)
   short ok;

   
   cout << "\n       TURN A CHANNEL 'ON'\n\n";
   cout << "   Please enter the port number: "; cin >> port_num;
   cout << "\n   Please enter the channel number (0-7): "; cin >> chan_num;

   ok = Set_Chan_On(port_num, chan_num);

   if (ok != 1)  {                         //error in processing
	cout << "\n   Error!!!";
//	getch();
	return;
   }

   cout << "\n\n   Channel " << chan_num << " is set to ON.";
//   getch();
   return;
}

//***************************************************************

void userSet_Chan_Off()  {

   short chan_num;    //channel (0-7)
   short port_num;    //port number (768, 769,...)
   short ok;

  
   cout << "\n       TURN A CHANNEL 'OFF'\n\n";
   cout << "   Please enter the port number: "; cin >> port_num;
   cout << "\n   Please enter the channel number (0-7): "; cin >> chan_num;

   ok = Set_Chan_Off(port_num, chan_num);

   if (ok != 1)  {                         //error in processing
	cout << "\n   Error!!!";
//	getch();
	return;
   }

   cout << "\n\n   Channel " << chan_num << " is set to OFF.";
//   getch();
   return;
}

//***************************************************************

void userGet_Channel()  {

   short chan_num;    //channel (0-7)
   short port_num;    //port number (768, 769,...)
   short on;

  
   cout << "\n       GET CHANNEL STATUS\n\n";
   cout << "   Please enter the port number: "; cin >> port_num;
   cout << "\n   Please enter the channel number (0-7): "; cin >> chan_num;

   on = Get_Channel(port_num, chan_num);

   if (on)  {
      cout << "\n\n    Channel number " << chan_num << " is ON.";
//      getch();
   }
   else  {
      cout << "\n\n    Channel number " << chan_num << " is OFF.";
      getch();
   }

   return;
}

//***************************************************************

void userGet_Port()  {

   short port_num;    //port number (768, 769,...)
   short val;         //value of the port

  
   cout << "\n       GET A PORT VALUE\n\n";
   cout << "   Please enter the port number: "; cin >> port_num;

   val = Get_Port(port_num);

   cout << "\n\n   The value of port " << port_num << " is " << val << ".";
//   getch();

   return;
}

//***************************************************************

void userSet_Port()  {

   short x;			//success flag
   short portval;                 //port value to be set
   short port_num;    		//port number (768, 769,...)

  
   cout << "\n       SET A PORT VALUE\n\n";
   cout << "   Please enter the port number to set: ";
   cin >> port_num;
   cout << "\n   Please enter the value to be set: ";
   cin >> portval;

   //store portval to port_num
   x = Set_Port(port_num, portval);

   //verify that it was stored correctly
   if (x != 1)  {
      cout << "\n   Error!!!";
  //    getch();
      return;
   }

   cout << "\n\n   The value of port " << port_num;
   cout << " was set to " << portval << ".";
 //  getch();
   return;
}

//***************************************************************

void userTO_On()  {

   short TO_num;    	//turnout number
   short ok;              //success flag

  
   cout << "\n       TURN TURNOUT to ON\n\n";
   cout << "   Please enter the turnout number: "; cin >> TO_num;

   ok = TO_On (TO_num);

   //verify that it was turned to on
   if (ok != 1)  {
      cout << "\n   Error!!!";
      getch();
      return;
   }

   cout << "\n\n   Turnout number " << TO_num << " is ON.";
   //getch();

   return;
}

//***************************************************************

void userTO_Off()  {

   short TO_num;    	//turnout number
   short ok;              //success flag

   
   cout << "\n       TURN TURNOUT to OFF\n\n";
   cout << "   Please enter the turnout number: "; cin >> TO_num;

   ok = TO_Off (TO_num);

   //verify that it was turned to off
   if (ok != 1)  {
      cout << "\n   Error!!!";
    //  getch();
      return;
   }

   cout << "\n\n   Turnout number " << TO_num << " is OFF.";
   getch();

   return;
}

//***************************************************************

void userToggle_TO()  {

   short TO_num;    	//turnout number
   short ok;              //success flag

  
   cout << "\n       TOGGLE TURNOUT (ON/OFF)\n\n";
   cout << "   Please enter the turnout number: "; cin >> TO_num;

   ok = TO_Toggle (TO_num);

   //verify that it was switched
   if (ok != 1)  {
      cout << "\n   Error!!!";
      getch();
      return;
   }

   cout << "\n\n   Turnout number " << TO_num << " is switched.";
   getch();

   return;
}


//***************************************************************

void userGet_TO_Position()  {

   short TO_num;      //turnout number (0-23)
   short position;    //position of the turnout (-1, 0, 1)

   
   cout << "\n       GET A TURNOUT POSITION\n\n";
   cout << "   Please enter the turnout number: "; cin >> TO_num;

   position = Get_TO_Status(TO_num);

   if (position < 0)
      cout << "\n\n   Turnout " << TO_num << " is turned to position A.";
   else if (position > 0)
      cout << "\n\n   Turnout " << TO_num << " is turned to position B.";
   else
      cout << "\n\n   Turnout " << TO_num << " is in middle position.";

   getch();
   return;
}





void main() {
//********************************************************************//
//                                                                    //
//              M   A  I  N      P  R  O  G  R  A  M                  //
//                                                                    //
//********************************************************************//

   char option;
   short  quit;

   do {
      //   Pashort the menu screen and input next option
      Menu(option);

      switch (option) {
      case '1':
	 userInitailize_Board();
	 break;
      case '2':
	 userToggle_TO();
	 break;
      case '3':
	 userSet_Chan_On();
	 break;
      case '4':
	 userSet_Chan_Off();
	 break;
      case '5':
	 userGet_Channel();
	 break;
      case '6':
	 userSet_Port();
	 break;
      case '7':
	 userGet_Port();
	 break;
      case '8':
	 userGet_TO_Position();
	 break;


      case '0': // EXIT
	 return;
      }// switch

   } while (1);   //forever

}//main
