﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace TestingSockets
{
    public partial class Server : Form
    {
        TcpListener MyListener = new TcpListener(IPAddress.Any, 10000);
        TcpClient MyClient;
        NetworkStream MyNetStream;

        public Server()
        {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            String Response = textBox1.Text.ToString();

            Byte[] SendTheseBytes = Encoding.ASCII.GetBytes(Response);

            MyNetStream.Write(SendTheseBytes, 0, SendTheseBytes.Length);
            textBox1.Text = "";
        }
        private void button3_Click(object sender, EventArgs e)
        {
            MyClient.Close();
            MyListener.Stop();
        }
        private void ReadMessages()
        {
            while (true)
            {
                if (MyNetStream.DataAvailable)
                {
                    byte[] bytes = new byte[MyClient.ReceiveBufferSize];
                    MyNetStream.Read(bytes, 0, (int)MyClient.ReceiveBufferSize);

                    string returndata = Encoding.ASCII.GetString(bytes);
                    //listBox1.Items.Add("This is what the host returned to you: " + returndata);
                    listBox1.Invoke(new DeliverMessagesCallback(DeliverMessages), new object[] { returndata });
                    MyNetStream.Flush();
                }
                Thread.Sleep(1000);
            }

        }
        private void DeliverMessages(string returndata)
        {
            try
            {
                listBox1.Items.Add("Client Says: " + returndata);
            }
            catch
            {
                MessageBox.Show("Error");
            }
            return;
        }

        public delegate void DeliverMessagesCallback(string returndata);

        private void Server_Shown(object sender, EventArgs e)
        {
            MyListener.Start();

            Thread ListenForClients = new Thread(new ThreadStart(StartListen));
            ListenForClients.Start();
        }


        private void StartListen()
        {
            listBox1.Items.Add("Waiting For Connection");

            while (true)
            {
                MyClient = MyListener.AcceptTcpClient();
                listBox1.Items.Add("Connection Established to" + MyClient.Client.AddressFamily.ToString());
                MyNetStream = MyClient.GetStream();

                Thread ListenForMessages = new Thread(new ThreadStart(ReadMessages));
                ListenForMessages.Start();
            }
        }
    }
}