//////Track Io Functions

#include <iostream.h>
#include <conio.h>
#include "windows.h"	
#include "dcc_comm.cpp"
//Globals for class
#define MAX_SENSOR	210
#define MAX_AIU		48
#define MIN_AIU		48

unsigned long DCC_Handle;

/* get AIU now in dcc_comm.cpp
bool GetAIU(char buffer[], int i){

	//Dummy handle
	HANDLE hcomm = (HANDLE)DCC_handle;

	char command[3];
	//Command to send to AIU to read it
	command[0] = 0x8A;	//command 
	command[1] = i;		// Cab Address
	command[2] = '\0';	// writecomm uses strlen to determine # bytes to send

	//hcomm is object of class track 
	// handle to com port file
	
	if(!writecomm(hcomm, command)){ // returns 0 on error 1 on succes
		//write error
		cerr << "WRITE FAILED\n";
		return false;
	}
	// after write wait
	Sleep(50);

	int result = readcomm(hcomm, buffer,4);
	if( result == -1){
		//read error
		cerr << "READ FAILED!\n";
		return false;
	}else if( result != 4){
		//incorrcect number of bytes read from com
		cerr << "NOT ENOUGH BYTES READ!\n";
		return false;
	}

	return true;


}
*/

void GetStatus(bool Sensors[], bool Changed[]){
	/*
	This function takes in two arrays of type bool. The array Sensors contains the actual
	value of the sensors at read time. The array changed indicates which sensors have changed since last
	read. It then reads all the inputs off of all the AIU units and places them in the arrays
	so that each sensor has its own zero-based index.
	*/

	char buffer[4];
	
	char temp;

	//unsigned long DCC_Handle;
	

	unsigned char  mask = 1;

	int i;
	// Iterate through AIUs and place bit values into sensor arrays
	for(i=MIN_AIU; i <= MAX_AIU; i++){
		if(!GetAIU(buffer, i, DCC_Handle)){
			//Error
			cerr << "GetAIU() CALL FAILED\n";
		}
		
		// have to swap high and low bytes or something
		temp = buffer[0];
		buffer[0] = buffer[1];
		buffer[1] = temp;
		temp = buffer[2];
		buffer[2] = buffer[3];
		buffer[3] = temp;


		int j;
		//Extract Bits from returned bytes
		for(j=0; j<14; j++){
			// bits 1-8 in buffer[0], bits 9-14 in buffer[1]
			// division by 8 should switch from [0] to [1] when appropriate
			if( buffer[j/8] & mask){ // True if mask bit sits on a lit bit in buffer[j/8]
				
				// Translate AIU number and bit number into a zero based index
				// Store True in Sensors[index]
				// for whatever reason the current state of the sensor is 
				// reported as the opposite of state of input( on = false)
				Sensors[((i-MIN_AIU)*14)+j] = false;
			}else{
				// Not true so set false
				Sensors[((i-MIN_AIU)*14)+j] = true;
			}

			// bits 1-8 in buffer[2], bits 9-14 in buffer[3]
			// division by 8 should switch from [2] to [3] when appropriate
			if( buffer[(j/8)+2] & mask){ // True if mask bit sits on a lit bit in buffer[j/8+2]

				// Translate AIU number and bit number into a zero based index
				// Store True in Sensors[index]
				Changed[((i-MIN_AIU)*14)+j] = true;
			}else{
				// Not true so set false
				Changed[((i-MIN_AIU)*14)+j] = false;
			}

			// shift mask bit left 1
			mask = mask << 1;
			// if mask is zero start back at one
			if(mask==0) mask=1;


		}
	}

}



void main(){ //DEBUGGIG - Test container for GetStatus

	bool Sensors[MAX_SENSOR];
	bool Changed[MAX_SENSOR];

	if(DCC_open("COM2", DCC_Handle)==0) cerr << "COM OPEN FAILED!\n";



	
	

	while(true){
		cout << "First Fourteen Sensors / Changed\n\n";
		
		GetStatus(Sensors, Changed);
		for(int i=0; i<14; i++){
			cout << i+1 << "  ";
			if(Sensors[i]){
				cout << "On  | ";
			}else{
				cout << "Off | ";
			}
			if(Changed[i]){
				cout << "On  \n";
			}else{
				cout << "Off \n";
			}
		}

		cout << flush;
		while(!kbhit());
		if(getch()=='q') break;

	}
	DCC_close(DCC_Handle);

	return;

}
	
