//---------------------------------------------------
//
// Author: John Moss
// Title:  Ultrasonic sensor test program
// Date:   Apr. 18, 2007
// Files:  ultra.cpp, ultra.h
//
// Equipment: Ultrasonic Range Finder
//              ->Devantech SRF02
//
//            USB Serial Interface Connector
//				->Acroname S19-USB-SERIAL-INT-CONN
//
//---------------------------------------------------

#include <stdio.h>
#include <windows.h>
#include "ultra.h"


int main(){

	int inches;
	
	SetupComm(comm, "COM8");		// comm port of ultrasonic sensor

	for(;;){						// infinite loop

		Send_FindRange();			// 0x50 command on default address
		Sleep(70);					// 70ms delay required by sensor
		Send_GetRange();			// 0x5E command on default address

		inches = Recv_GetInches();  // read from comm and convert
		ShowInches(inches);			// output to console

		Sleep(50);					// prevents comm port hammering
	}

	return 0;
}
