﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Pipes;
using System.IO.Ports;
       /***************************************************************
       * This form located all serial connections on the computer
       * Note the fact that its serial, not USB...since there is a
       * Different protocol for USB, and we aren't using USB, I did not 
       * Deem it necessary here. (since the powerhouse only uses rs232, it will still be
        * recognized as serial with a rs232 to usb adapter
       * **************************************************************/

namespace CCR
{
    public partial class PortSelect : Form
    {
        public PortSelect()
        {
            InitializeComponent();
        }

        private void PortSelect_Shown(object sender, EventArgs e)
        {
            refreshButton_Click(sender, e);
        }

        private void refreshButton_Click(object sender, EventArgs e)
        {
            availablePorts.Items.Clear();
            foreach (string PortNames in System.IO.Ports.SerialPort.GetPortNames())
                availablePorts.Items.Add(PortNames);
            if (availablePorts.Items.Count > 0)
                availablePorts.SelectedIndex = 0;
            else if (availablePorts.Items.Count <= 0)
                MessageBox.Show("No Ports Available");
        }

        private void portSelectButton_Click(object sender, EventArgs e)
        {
            if (availablePorts.SelectedIndex >= 0)
            {
                string select = availablePorts.SelectedItem.ToString();
                Receive rec = new Receive(select);
                rec.Show();
                this.Visible = false;
            }
            else
                MessageBox.Show("No Selection Made");
        }
        private void availablePorts_DoubleClick(object sender, EventArgs e)
        {
            portSelectButton_Click(sender, e);
        }

        
    }
}
