#if !defined CTRAINCONTROL_H

#define CTRAINCONTROL_H

#include "ResourceManager.h"
#include <afxcmn.h>	
#include "MyToolTip.h"


class CTrainControl:public CFrameWnd {

  public:

	 CTrainControl(Train * T, ResourceManager * R);
/////////////////////////////////////////////////////////////////////////
//Construct a Train Control to allow a user to control a single train
//Sets its pointer to the resource manager it needs to call to send
// train commands and create the window.  Sets timer to update data from 
// Train
//////////////////////////////////////////////////////////////////////

	 ~CTrainControl();
///////////////////////////////////////////////////////////////////
//Kills timer 3
//////////////////////////////////////////////////////////////////////////

	 afx_msg int OnCreate(LPCREATESTRUCT lpcs);
///////////////////////////////////////////////////////////////////////
//Creates the display for the window in relative size to chosen font and 
//Creates all buttons, Labels, and Controls for a train
////////////////////////////////////////////////////////////////////

	 afx_msg void OnTimer();
/////////////////////////////////////////////////////////////////////////
//Called when timer fires.  Updates current train status by calling get methods
//in train
// updates allocation status, photocell and turnout, speed, blocked status, and
//headlight/taillight
////////////////////////////////////////////////////////////////////////////////

	 afx_msg void OnPaint();
////////////////////////////////////////////////////////////////////
//repaint the rect gray
////////////////////////////////////////////////////////////////

	 afx_msg void OnStop();
/////////////////////////////////////////////////////////////////
//Traps user clicked Brake button calls resourcemanager method to 
//make train stop
////////////////////////////////////////////////////////////////

	 afx_msg void OnChangeDirection();
/////////////////////////////////////////////////////////////////
//Traps user pressing ChangeDirection and calls resource manager method
// to change the direction of a train
/////////////////////////////////////////////////////////////////////

	 afx_msg void OnHeadLightToggle();
/////////////////////////////////////////////////////////////////////////
//Traps user pressing headlight button and calls resource manager to toggle
//headlight of train
////////////////////////////////////////////////////////////////////////////

	 afx_msg void OnTailLightToggle();
/////////////////////////////////////////////////////////////////////////
//Traps user pressing taillight button and calls resource manager to toggle
//taillight of train
////////////////////////////////////////////////////////////////////////////

     afx_msg void OnVScroll (UINT nCode, UINT nPos, CScrollBar* pScrollBar);
////////////////////////////////////////////////////////////////////////////
//Traps scrolling inside of speed control and uses resource manager to set the 
//speed of a train
/////////////////////////////////////////////////////////////////////////////

afx_msg virtual void PostNcDestroy();  // added by bmcvey .. stops crash when
                                       // hitting close icon on train control
  protected:

	  // Buttons and TextOutput Boxes for this window
	  CButton ChangeDirectionButton;
	  CButton StopButton;
	  CButton HeadLightToggleButton;
	  CButton TailLightToggleButton;
	  CStatic ModeText;
	  CStatic DirectionAroundTrackText;
	  CStatic PhotocellhasText;
	  CStatic PhotocellnextText;
	  CStatic TurnoutHas;
	  CStatic DirectionText;
	  CButton PhotocellResourceGroupBox;
	  CButton TurnoutResourceGroupBox;
	  CStatic BlockedStatusText;
	  CEdit SpeedEditBox;
	  CSpinButtonCtrl SpeedControl;
	  CButton TrainInfoGroupBox;
	  CButton TrainSpeedGroupBox;
	  CButton LightsGroupBox;
	  CButton DirectionGroupBox;
	 
	  //Tool tips
	  CMyToolTipCtrl m_ctlTTrainControl;


	  CFont m_font; //font for this screen

	  int m_cxChar; //avg width of char

	  int m_cyChar;	//avg height of char

	  COLORREF WindowBackgroundColor; //background color

	  ResourceManager  * MyResMng;	//resource manager to call fucntions

	  Train * MyTrain; //Pointer to the train this window controls

	  DECLARE_MESSAGE_MAP()

}; 


#endif




