#if !defined TRACKLIST_H

#define TRACKLIST_H

#include "Node.h"


const int CURVED = 1;
const int STRAIGHT = -1;
const int NOTURNOUT = 2;
const int MOVING = 0;
const int MAXPHOTOCELLS = 16;
const int MAXTURNOUTS = 7;
const int MAXSPEED = 16;

class TrackList {

  public:

    TrackList(); 
///////////////////////////////////////////////////
//   Create a new TrackList
////////////////////////////////////////////////

    int Add(int pc, int to,  int sd);
//////////////////////////////////////////////////////////////////////////////
//Adds a node to the TrackList. Creates a new Node defined in Node.h and adds
//it to the front of the list be making the header node point to it and making
//it point to the old node top used to point to
//Returns 1 if successfully added 0 if not
/////////////////////////////////////////////////////////////////////////////
    void Clear();
////////////////////////////////////////////////////////////////////////////
//	clears all members of the current TrackList
/////////////////////////////////////////////////////////////////////////////
	int FindPCNext();
///////////////////////////////////////////////////////////////////////////////
//Given a tracklist this function finds the next photocell giving the current
//track state.  Uses Get_TO_Status(int to) to read the current state of the 
//turnouts to compute what photocell is next. Called from HandleArrival in
//ResourceManager
////////////////////////////////////////////////////////////////////////////

	int FindPCNext(int switchdirection);
//////////////////////////////////////////////////////////////////////////////
//Returns the next PC assuming that the next Turnout is in the state of the inputed
//switchdirection Used if BatchProcessing is going on and a user wants to check to see
//what the next pc is without actually switching the state of a turnout because that 
//is slow
/////////////////////////////////////////////////////////////////////////////////
	int FindToNext();
//////////////////////////////////////////////////////////////////////////////
//Returns the Turnout related to this TrackList
//////////////////////////////////////////////////////////////////////////////
	int FindSwitchDirection(int pc);
/////////////////////////////////////////////////////////////////////////
//Finds the necessary turnout diretion to find to get to the inputed photocell
//value
////////////////////////////////////////////////////////////////////////////

  private:
    Node *top;  // pointer to top of the list.

}; // List



#endif