#include <afxwin.h>
#include "CUserScreen.h"
#include "Constants.h"
#include "ResourceManager.h"



CUserScreen::CUserScreen()
{


	CRect Rect(0,0,500, 500);  //define oringal window
	Create(0, "User Window", WS_OVERLAPPEDWINDOW, Rect, NULL, "CUSERSCREENMENU");  //create new window

 	CRect MyRect(0, 0, m_cxChar*40,  m_cyChar * 10); 
	// comes back with m_cxChar and my_cyChar defined set up new rect for new window
										

	CalcWindowRect(&MyRect);  // calc pixel width and height for window

	SetWindowPos(NULL, 0, 0, MyRect.Width() , MyRect.Height(), 
		         SWP_NOZORDER | SWP_NOMOVE | SWP_NOREDRAW);


	MyResourceManager = new ResourceManager("ResourceLog.txt");
	MyResourceManager->ShowWindow(SW_SHOWMAXIMIZED);
	MyResourceManager->UpdateWindow();


	Train R(1,"Burlington", 8, 0, -1, INTERACTIVE, "");
	MyResourceManager->AddTrainToTrack(R);
	Train T(2, "Hello", 7, 15, 2, INTERACTIVE, "");
	MyResourceManager->AddTrainToTrack(T);
	Train * Q = new Train(R); 
	TrainControls[0] = new CTrainControl(Q, MyResourceManager);
	TrainControls[0]->ShowWindow(SW_SHOWNORMAL);
	TrainControls[0]->UpdateWindow();




//	SetTimer( 2, 1000, NULL ); // set timer for every second


}



CUserScreen::~CUserScreen(){


	delete MyResourceManager;

}





int CUserScreen::OnCreate(LPCREATESTRUCT lpcs){


	if (CWnd::OnCreate(lpcs) == -1)
		return -1; //return if not good


	m_font.CreatePointFont(80, _T("MS Sans Serif"));  //select our font
	CClientDC dc (this);  //get handler to compute text averages
	CFont * pOldFont = dc.SelectObject(&m_font); // select our font

	TEXTMETRIC Tm; // get Textmetric

	dc.GetTextMetrics(&Tm);  // and give it our font to calculate
	m_cxChar = Tm.tmAveCharWidth;  // store average width
	m_cyChar = Tm.tmHeight + Tm.tmExternalLeading;	// and height

	dc.SelectObject(pOldFont); // return old pen to not consume resources

	return 0;


}//Oncreate


afx_msg void CUserScreen::OnToggleTo()
{


	MyResourceManager->ToggleTurnout(1);



}


afx_msg void CUserScreen::OnPaint(){


   CPaintDC dc( this );   //get paint handler
   
 
}//OnPaint




afx_msg void CUserScreen::OnDestroy()
{

     
//	KillTimer( 2 );   //kill timer 1

}





afx_msg void CUserScreen::OnTimer()
{


  

	

}






BEGIN_MESSAGE_MAP(CUserScreen, CFrameWnd)

	
	ON_WM_CREATE()

	ON_WM_TIMER()    

	ON_WM_PAINT()   

	ON_COMMAND(IDM_TO, OnToggleTo)

END_MESSAGE_MAP()