#if !defined RESOURCEMANAGER_H

#define RESOURCEMANAGER_H
#define TRUE 1
#define FALSE 0
#define BLOCK 0
#define NOTBLOCK 1
#define UNCOVERED  0
#define  COVERED 1


#include "train.h"
#include "TrackList.h"
#include "TrainList.h"
#include <afxwin.h>
#include <fstream>

using namespace std;


class ResourceManager:public CFrameWnd
{
public:

	ResourceManager(char Filename[80]);
	~ResourceManager();

	int GetPhotoCellManager(int index);
	int GetTurnoutManager(int index);

	int AddTrainToTrack(Train & T);
	int DeleteTrainFromTrack(int id);


	int ToggleTurnout(int to);
	int SetSpeed(int id, int newspeed);
	int IncreaseSpeed(int id, int increment = 1);
	int DecreaseSpeed(int id, int increment = 1);
	int Stop(int id);
	int ChangeDirection(int id);
	int TurnHeadLightOn(int id, int on);
	int ToggleHeadLight(int id);
	int TurnTailLightOn(int id, int on);
	int ToggleTailLight(int id);


private:


	void AllocateResources(Train * T, int pc, int to);
	void DeallocateResources(Train * T);
	int UpdateResources(Train * T, int pc, int to);

	void LoadTrack();
    void HandleArrival(int photocell);
	void HandleDeparture(int photocell);

	int TurnoutOpposite(int to);
	void ActiveToBlocked(Train * T);
	void BlockedToActive(Train * T);
	void ReleaseBlockedTrains(int ReleasedPhotocell);
	void BatchToSwitch(Train * T, int pc, int to);

	void TrainPrint(Train * T);
	void ResourceTablesPrint();


	 afx_msg int OnCreate(LPCREATESTRUCT lpcs);

	 afx_msg void OnTimer();

	 afx_msg void OnDestroy();

	 afx_msg void OnPaint();

	 int GetPhotoCellStatus(int pc);

	 void UpdateCurrentPCStatus();

	int PhotocellManager[MAXPHOTOCELLS];
	int TurnoutMng[MAXTURNOUTS];
    TrackList CW[MAXPHOTOCELLS];
    TrackList CC[MAXPHOTOCELLS];
	TrainList ActiveTrains;
	TrainList BlockedTrains;
	bool Fileopen;
	char Filename[80];

	ofstream Output;

	CFont m_font;

	int m_cxChar;

	int m_cyChar;

	int CurrentPCState[MAXPHOTOCELLS];

	int PreviousPCState[MAXPHOTOCELLS];



   DECLARE_MESSAGE_MAP()

};


#endif



