#if !defined TRAIN_H

#include <fstream>
#include <string>
using namespace std;

#define TRAIN_H

const int BATCH = 0;
const int INTERACTIVE = 1;

const int CLOCKWISE = 1;
const int COUNTERCLOCKWISE = 0;
const int FORWARD = 1;
const int REVERSE = 0;

const int ON = 1;
const int OFF = 0;


const int SENTCOMMAND = 1;
const int QUEUECOMMAND = 0;

const int SIZEOFINPUTFILE = 100;

class Train
{
public:

	Train(int Id1, char Name[], int PhotocellHas1, int PhotocellNext1, int TurnoutHas1, 
		  int Mode1, char Filename[], int MaxSpeed1 = 16, int DirectionAroundTrack1 = CLOCKWISE, 
		  int Direction1 = FORWARD);


	Train( const Train & T);

	virtual ~Train();

	int GetId();

	int GetSpeed();

	int GetPhotocellHas();

	int GetLastPhotocellCovered();

	int GetPhotocellNext();

	int GetTurnoutHas();

	int GetBlockingPhotocell();

	int GetDirectionAroundTrack();

	int GetDirection();

	int GetHeadLight();

	int GetTailLight();

	int GetMode();

	char * GetName();

	Train * link;

	friend class ResourceManager;
	



private:


	int SetSpeed(int newspeed);

	int IncreaseSpeed(int increment = 1);

	int DecreaseSpeed(int increment = 1);

	int Stop();

	int ChangeDirection();

	int TurnHeadLightOn(int on);

	int ToggleHeadLight();

	int TurnTailLightOn(int on);

	int ToggleTailLight();

	int ReadPhotocell();

	int Id;
	int Speed;
	int MaxSpeed;
	int OldPhotocellHas;
	int PhotocellHas;
	int PhotocellNext;
	int TurnoutHas;
	int OldTurnoutHas;
	int LastPhotocellCovered;
	int DirectionAroundTrack;
	int Direction;
	int HeadLight;
	int TailLight;
	int Mode;
	int BlockInstructions;
	int BlockingPhotocell;
	char Name[30];
	char DCCLastCommand[15];
	string InputFile[SIZEOFINPUTFILE];
	char Filename[80];

	
};


int checkdir(int speed, int direction);
int makecommand(int type, int instruction, int id, char command[]);
void swap(int & x, int & y);
void StringArrayCopy(string to[], string from[], int size);


#endif


