#include <afxwin.h>
#include "Constants.h"
#include "PhotoCellManager.h"
#include "Train.h"
#include "ccr.h"



PhotoCellManager::PhotoCellManager(ResourceManager * R){


	CRect Rect(0,0,500, 500);  //define oringal window
	Create(0, "PhotoCellManager", WS_OVERLAPPEDWINDOW, Rect, NULL, 0);  //create new window

 	CRect MyRect(0, 0, m_cxChar*40,  m_cyChar * 10); 
	// comes back with m_cxChar and my_cyChar defined set up new rect for new window
										

	CalcWindowRect(&MyRect);  // calc pixel width and height for window

	SetWindowPos(NULL, 0, 0, MyRect.Width() , MyRect.Height(), 
		         SWP_NOZORDER | SWP_NOMOVE | SWP_NOREDRAW);


	
	int PortStatus = Open_Ports();
	int InitStatus = Initialize_Board(1, 0, 0, 0, 0);
	InitStatus = Initialize_Board(2, 1, 1, 1, 1);
	InitStatus = Initialize_Board(3, 1, 1, 1, 1);
    InitStatus = Initialize_Board(4, 1, 1, 1, 1);


	for (int i = 0; i<MAXPHOTOCELLS; i++){
		PreviousPCState[i] = 0;
		CurrentPCState[i] = 0;
	}

	ResMng = R;   //NEVER EVER DELETE RESMNG OR R UNDER PENALTY OF DEATH



	SetTimer( 1, 5000, NULL ); // set timer for every second


}




int PhotoCellManager::OnCreate(LPCREATESTRUCT lpcs){


	if (CWnd::OnCreate(lpcs) == -1)
		return -1; //return if not good


	m_font.CreatePointFont(80, _T("MS Sans Serif"));  //select our font
	CClientDC dc (this);  //get handler to compute text averages
	CFont * pOldFont = dc.SelectObject(&m_font); // select our font

	TEXTMETRIC Tm; // get Textmetric

	dc.GetTextMetrics(&Tm);  // and give it our font to calculate
	m_cxChar = Tm.tmAveCharWidth;  // store average width
	m_cyChar = Tm.tmHeight + Tm.tmExternalLeading;	// and height

	dc.SelectObject(pOldFont); // return old pen to not consume resources

	return 0;


}//Oncreate




afx_msg void PhotoCellManager::OnPaint(){


   CPaintDC dc( this );   //get paint handler
   
 
}//OnPaint




afx_msg void PhotoCellManager::OnDestroy(){

     
	KillTimer( 1 );   //kill timer 1

}





afx_msg void PhotoCellManager::OnTimer(){


	int i = 0;

	if (CurrentPCState[i] > PreviousPCState[i]){

		ResMng->HandleArrival(i);

		
	}


	else if (CurrentPCState[i] < PreviousPCState[i]){

		   ResMng->HandleDeparture(i);

	}


	   PreviousPCState[i] = CurrentPCState[i];
	   



}




int PhotoCellManager::GetPhotoCellStatus(int pc){

	return CurrentPCState[pc];

}


void PhotoCellManager::UpdateCurrentPCStatus(){


	for (int i = 0; i< MAXPHOTOCELLS; i++)
		CurrentPCState[i] = Get_Sensor_Status(i);

}


void PhotoCellManager::SetArrival(int photocell){


	CurrentPCState[photocell] = COVERED;
	PreviousPCState[photocell] = UNCOVERED;
	

}

void PhotoCellManager::SetDeparture(int photocell){


	CurrentPCState[photocell] = UNCOVERED;
	PreviousPCState[photocell] = COVERED ;


}






BEGIN_MESSAGE_MAP(PhotoCellManager, CFrameWnd)
	
	ON_WM_CREATE()

	ON_WM_TIMER()    

	ON_WM_PAINT()   


END_MESSAGE_MAP()