#include <fstream>
#include "TrackList.h"
#include "ActiveTrainList.h"
#include "ResourceManager.h"
#include "ccr.h"

using namespace std;


ResourceManager::ResourceManager(){


	for (int i = 0; i<MAXPHOTOCELLS; i++)
		PhotocellManager[i] = 0;

	for (i = 0; i< MAXTURNOUTS; i++)
		TurnoutMng[i] = 0;

	LoadTrack();
}




ResourceManager::~ResourceManager(){


}


int ResourceManager::UpdateResources(Train * T, int pc, int to){


	if (PhotocellManager[pc] == 0)
	{
		if (to != -1)
		{
			if (TurnoutMng[to] == 0)
			{
				AllocateResources(T,pc,to);
				return TRUE;
			}
			else
				return FALSE;
			
		}
		else 
		{
			AllocateResources(T,pc,to);
			return TRUE;
		}

	}

	else 
		return FALSE;


}


void ResourceManager::AllocateResources(Train * T, int pc, int to){


		T->OldPhotocellHas = T->PhotocellHas;
		T->OldTurnoutHas = T->TurnoutHas;

		T->PhotocellHas = T->PhotocellNext;
		T->PhotocellNext = pc;
		T->TurnoutHas = to;

		PhotocellManager[T->PhotocellHas] = T->Id;
		PhotocellManager[T->PhotocellNext] = T->Id;

		if (to != -1){
			TurnoutMng[to] = T->Id;
		}

	

}


void ResourceManager::DeallocateResources(Train * T)
{

  	   PhotocellManager[T->OldPhotocellHas] = 0;

		if (T->OldTurnoutHas != -1)
			TurnoutMng[T->OldTurnoutHas] = 0;

}

int ResourceManager::DepartResouceUpdate(Train * T){


	return 1;

}


void ResourceManager::PrintResourceTables(){

	for (int j= 0; j < MAXPHOTOCELLS; j++){
	//	cout << "photocell " << j << " is:   " << PhotocellManager[j] << endl;
	}


//	cout << "TO Manager" << endl;


	for (j = 0; j< MAXTURNOUTS; j++){
	 //	cout << "turnout " << j << " is:   " << TurnoutMng[j] << endl;
	}

}



int ResourceManager::AddTrainToTrack(Train & T){


   
	if (T.GetId() > 0 &&  ActiveTrains.Find(T.GetId()) == NULL){
		

		

		if (PhotocellManager[DEFPHOTOCELLHAS] == 0 && PhotocellManager[DEFPHOTOCELLNEXT] == 0){

							       // points to new node
		    ActiveTrains.Add(T);
			
			PhotocellManager[DEFPHOTOCELLHAS] = T.GetId();
			PhotocellManager[DEFPHOTOCELLNEXT] = T.GetId();

			return 1;


		}

		else return -1;
			//cout << "Cannot Add Train right now Train blocking " << endl;


	}

	else
	//	cerr << "Error invalid id number--must be positive and unique" << endl;
		return -2;




 

} // Add


void ResourceManager::ActiveToBlocked(Train * T)
{


	Train *prev, *p;          // used for tag along

	prev=ActiveTrains.top;
	p=ActiveTrains.top-> link;

	while (p!=ActiveTrains.top)
	{

		if (p->GetId() == T->GetId())
		{
		    prev-> link =p -> link;
		    delete p;
			
		}

	  prev=p;
	  p=p->link;
	}


}




void ResourceManager::BlockedToActive(Train * T)
{







}


int ResourceManager::DeleteTrainFromTrack(int id) {
//*******************************************************************
//   Deletes the node with "keyval" from this list.
//*******************************************************************

	Train *prev, *p, *MyTop;          // used for tag along


	if (ActiveTrains.Find(id) != NULL)
	{

		MyTop = ActiveTrains.top;
		prev=ActiveTrains.top;
		p=ActiveTrains.top-> link;

	}
	else if (BlockedTrains.Find(id) != NULL)
	{

		MyTop = BlockedTrains.top;
		prev = BlockedTrains.top;
		p = BlockedTrains.top;

	}

	while (p!=MyTop)
	{

		if (p->GetId() == id)
		{
		    prev-> link =p -> link;
			PhotocellManager[p->GetPhotocellHas()] = 0;
			PhotocellManager[p->GetPhotocellNext()] = 0;

			if (p->GetTurnoutHas() != -1)
				TurnoutMng[p->GetTurnoutHas()] = 0;
		    delete p;
			return 1;
		}

	  prev=p;
	  p=p->link;
	}

	return 0;


} // Delete



void ResourceManager::HandleArrival(int photocell){


		int id = PhotocellManager[photocell];

		Train * T = ActiveTrains.Find(id);

		T->LastPhotocellCovered = photocell;

		int pc;
		int to;
		
			if (T == NULL)
			{
			   //Train not in that location handle it
			}

			if (T->GetDirectionAroundTrack() == CLOCKWISE){
				pc = CW[photocell].FindPCNext();
				to = CW[photocell].FindToNext();
			}
			else if (T->GetDirectionAroundTrack() == COUNTERCLOCKWISE)
			{
				pc = CC[photocell].FindPCNext();
				to = CC[photocell].FindToNext();
			}



			if (pc != -1)
			{

				if (!UpdateResources(T,pc,to))

				{

					/*cout << "Resources Not Available" << endl;

					T->BlockingPhotocell = pc;
					T->BlockingTurnout = to;

					BlockedTrains.Add(T);
					BlockedTrains.Print();
					ResMng.PrintResourceTables();*/

				}

			}		
				
				
				
				
			else if (T->GetMode() == BATCH)
			{

				if (T->GetDirectionAroundTrack() == CLOCKWISE)
					pc = CW[photocell].FindPCNext(TurnoutOpposite(to));
		    	else if (T->GetDirectionAroundTrack() == COUNTERCLOCKWISE)
					pc = CC[photocell].FindPCNext(TurnoutOpposite(to));
				

				TO_Toggle(to);

				if (!UpdateResources(T,pc,to))
				{

				/*
					cout << "Resources Not Available Train Blocked" << endl;
					ResMng.PrintResourceTables();
					T->BlockingPhotocell = pc;
					T->BlockingTurnout = to;
					BlockedTrains.Add(T);
				*/


				}

			}
			
			else if (T->GetMode() == INTERACTIVE)
			{
			

				/*T->BlockingPhotocell = pc;
				T->BlockingTurnout = to;
				BlockedTrains.Add(T);
				BlockedTrains.Print();*/

			}
		

}




void ResourceManager::HandleDeparture(int photocell)
{

	int id = PhotocellManager[photocell];

	Train * T = ActiveTrains.Find(id);

	DeallocateResources(T);


	//attempt to release trains from blocked list here


}




int ResourceManager::GetPhotoCellManager(int index){

	return PhotocellManager[index];

}





int ResourceManager::GetTurnoutManager(int index){

	return TurnoutMng[index];


}


int ResourceManager::TurnoutOpposite(int to){


	if (Get_TO_Status(to) == STRAIGHT)
		return CURVED;
	else if (Get_TO_Status(to) == CURVED)
		return STRAIGHT;
	else 
		return MOVING;


}


void ResourceManager::LoadTrack(){


	CW[0].Add(2,1,STRAIGHT);
	CW[1].Add(2,1,CURVED);
	CW[2].Add(7,-1,NOTURNOUT);
	CW[3].Add(1,0,STRAIGHT);
	CW[4].Add(12,6,STRAIGHT);
	CW[4].Add(12,6,CURVED);
	CW[5].Add(4,-1,NOTURNOUT);
//	CW[6].Add(12,-1,NOTURNOUT);
	CW[7].Add(15,2,STRAIGHT);
	CW[8].Add(0,-1,NOTURNOUT);
	CW[9].Add(3,-1,NOTURNOUT);
//	CW[10].Add(-1,-1,NOTURNOUT);
	CW[11].Add(5,6,CURVED);
	CW[11].Add(5,6,STRAIGHT);
	CW[12].Add(15,2,CURVED);
	CW[13].Add(8,4,STRAIGHT);
	CW[13].Add(9,4,CURVED);
	CW[14].Add(11,-1,NOTURNOUT);
	CW[15].Add(13,3,STRAIGHT);
	CW[15].Add(14,3,CURVED);


	CC[0].Add(8,-1,NOTURNOUT);
	CC[1].Add(3,0,STRAIGHT);
	CC[2].Add(1,1,CURVED);
	CC[2].Add(0,1,STRAIGHT);
	CC[3].Add(9,-1,NOTURNOUT);
	CC[4].Add(5,-1,NOTURNOUT);
	CC[5].Add(11,6,STRAIGHT);
	CC[5].Add(11,6,CURVED);
//	CC[6].Add(5,-1,NOTURNOUT);
	CC[7].Add(2,-1,STRAIGHT);
	CC[8].Add(13,4,STRAIGHT);
	CC[9].Add(13,4,CURVED);
//	CC[10].Add(-1,-1,-1,NOTURNOUT);
	CC[11].Add(14,-1,NOTURNOUT);
	CC[12].Add(4,6,STRAIGHT);
	CC[12].Add(4,6,CURVED);
	CC[13].Add(15,3,STRAIGHT);
	CC[14].Add(15,3,CURVED);
	CC[15].Add(7,2,STRAIGHT);
	CC[15].Add(12,2,CURVED);

}


/*

void main(){

	ResourceManager R;
	R.PrintResourceTables();

	Train x(1, 12);

	x.Print();

	TrainList Y;

	Y.Add(&R, 2, 13);

	Y.Add(&R, 3, 13);

	Y.Print();






}

  */

  