#if !defined RESOURCEMANAGER_H

#define RESOURCEMANAGER_H
#define TRUE 1
#define FALSE 0

#include "train.h"
#include "TrackList.h"
#include "TrainList.h"
//#include "ActiveTrainList.h"

class ResourceManager
{
public:

	ResourceManager();
	~ResourceManager();

	void PrintResourceTables();
	void AllocateResources(Train * T, int pc, int to);
	void DeallocateResources(Train * T);
	int UpdateResources(Train * T, int pc, int to);
	int DepartResouceUpdate(Train * T);
	int GetPhotoCellManager(int index);
	int GetTurnoutManager(int index);
	void LoadTrack();
    void HandleArrival(int photocell);
	void HandleDeparture(int photocell);
	int AddTrainToTrack(Train & T);
	int DeleteTrainFromTrack(int id);
	int TurnoutOpposite(int to);
	void ActiveToBlocked(Train * T);
	void BlockedToActive(Train * T);

private:


	int PhotocellManager[MAXPHOTOCELLS];
	int TurnoutMng[MAXTURNOUTS];
    TrackList CW[MAXPHOTOCELLS];
    TrackList CC[MAXPHOTOCELLS];
	TrainList ActiveTrains;
	TrainList BlockedTrains;
};


#endif


