#include <iostream>
#include <conio.h>
#include <stdlib.h>
#include "node.h"
#include "Qnode.h"
#include "Queue.h"
#include "ResourceManager.h"
#include "TrackList.h"
#include "train.h"
#include "TrainList.h"
#include "Console.h"
#include "ActiveTrainList.h"
#include "BlockedTrainList.h"


using namespace std;

void LoadTrack(TrackList CW[], TrackList CC[]);
void ToggleToStatus(int Turnouts[], int to);
void PrintToStatus(int Turnouts[]);
void PrintMenu();
int Opposite(int Turnouts[], int to);


void main(){


	ResourceManager ResMng;
	ActiveTrainList ActiveTrains;
	BlockedTrainList BlockedTrains;

	int OldHasTo;


//	Train X(1, 2, 3);
//	Train Y(2, 3, 4);

//	BlockedTrains.Add(&X);

//	BlockedTrains.Add(&Y);

//	BlockedTrains.Print();

	int Turnouts[MAXTURNOUTS];

	int resgood;

	int OldHas;


	Turnouts[0]	= STRAIGHT;
	Turnouts[1] = STRAIGHT;
	Turnouts[2]	= STRAIGHT;
	Turnouts[3] = CURVED;
	Turnouts[4] = CURVED;
	Turnouts[5] = CURVED;
	Turnouts[6] = CURVED;

	TrackList CW[MAXPHOTOCELLS];
	TrackList CC[MAXPHOTOCELLS];

	LoadTrack(CW, CC);


	int id;
	int MaxSpeed;
	int to;
	int read;
	int pc;
	int Mode;
	Train * T;

	cout << "Welcome to Train OS Version 0.1" << endl;
	cout << "Enter Command Number 21 for menu" << endl;
	cout << "Please enter id for the initial train on the track: "; 
	cin >> id;
	cout << "Enter this Train's MaxSpeed: ";
	cin >> MaxSpeed;
	cout << "Enter Mode of this Train: ";
	cin >> Mode;
	
	ActiveTrains.Add(&ResMng, id, MaxSpeed, Mode);


	cout << "Enter command number (21 for menu): " ;
	cin >> read;


	ClrScr();

	while (read != -1){

	
		if (read == 16){
			cout << "Which turnout: " ;
			cin >> to;
			ToggleToStatus(Turnouts, to);
			cout << "turnout " << to << " is " << Turnouts[to] << endl;

		/*	if (tochange[to] != 0){
			
				
				cout << "system is checking to see if any trains can be woken up" << endl;

				id = tochange[to];
				thistrain = FindTrain(id);
				GetNext(thistrain, thistrain->pnext, pc, to);
				cout << "Next PC: " << pc << "    Next TO: " << to << endl;
				goto here;




			}

  */

		
		
  

		}

		else if (read == 17){

			cout << "Which  to switch direction: " << endl;
	        cin >> id;
			Train * thistrain = ActiveTrains.Find(id);

			if (thistrain == NULL){
				cerr << "Error in operating system Train Was not found";
				getch();
				exit(124);
			}

			thistrain->ChangeDirection();

			cout << "direction switched to " << thistrain->GetDirectionAroundTrack() << endl;
		
		

		}

		else if (read == 18){
		
			cout << "New Train id: " ;
			cin >> id;
			cout << "Max Speed: ";
			cin >> MaxSpeed;
			cout << "Enter Mode of this Train: ";
			cin >> Mode;

			ActiveTrains.Add(&ResMng, id, MaxSpeed, Mode);

		
		

		}

		else if (read == 19){

			ResMng.PrintResourceTables();
		
		
		}


	
  
		else if (read == 20){
			PrintToStatus(Turnouts);
		
		
		}

		else if (read == 21){
			PrintMenu();
		
		
		}

		else if (read >= 0 && read <= 15){

					
			id = ResMng.GetPhotoCellManager(read);

			T = ActiveTrains.Find(id);

			OldHas = T->GetBlockingPhotocell();
			OldHasTo = T->GetBlockingTurnout();

		
			if (T == NULL){
				cerr << "Error in operating system Train Was not found" << endl;
				getch();
				exit(125);
			}

			if (T->GetDirectionAroundTrack() == CLOCKWISE){
				pc = CW[read].FindPCNext(Turnouts);
				to = CW[read].FindToNext();
			}
			else {
				pc = CC[read].FindPCNext(Turnouts);
				to = CC[read].FindToNext();
			}

		


		cout << "Train " << T->GetId() << " Next PC: " << pc << "      Next to: " << to << endl;


			if (pc == -1 && T->GetMode() == BATCH){

				if (T->GetDirectionAroundTrack() == CLOCKWISE){
					pc = CW[read].FindPCNext(Opposite(Turnouts, to));
					to = CW[read].FindToNext();
				}

		    	else {

				pc = CC[read].FindPCNext(Opposite(Turnouts, to));
				to = CC[read].FindToNext();

			}

				cout << "Next PC after adjustment: " << pc << "      Next to: " << to << endl;
				resgood = ResMng.CheckResourceAvail(pc, to);

			if (resgood){

			    cout << "System found that toggling turnout in batch mode is safe...toggling to " << to;
				ToggleToStatus(Turnouts, to);
				ResMng.UpdateResources(T, pc, to);


			}

			else{

				cout << "Resources Not Available Train Blocked" << endl;
				ResMng.PrintResourceTables();
				T->BlockingPhotocell = read;
				T->BlockingTurnout = to;
				BlockedTrains.Add(T);

			}



		}
		else if (pc == -1 && T->GetMode() == INTERACTIVE){
			cout << "stop the train due to turnout in position that makes" << endl 
				 << "further travel impossible. Please toggle turnout " << to << endl;

			T->BlockingPhotocell = read;
		   T->BlockingTurnout = to;
			BlockedTrains.Add(T);
			BlockedTrains.Print();

		}
		
		else if (pc != -1){

			resgood = ResMng.CheckResourceAvail(pc, to);
			if (resgood){
				ResMng.UpdateResources(T, pc, to);
			}
			else{

				cout << "Resources Not Available" << endl;

				T->BlockingPhotocell = read;
				T->BlockingTurnout = to;

				BlockedTrains.Add(T);
				BlockedTrains.Print();
				ResMng.PrintResourceTables();

			}

		}



		cout << endl << "Release Possible: " << BlockedTrains.ReleasePossible(OldHas, OldHasTo) << endl;



		cout << "Would you like to see the resource tables" << endl;
		if (toupper(getch()) == 'Y'){
			ResMng.PrintResourceTables();
		}

	
	

		}

		else {

			cout << "Invalid Command " << endl;

		}


		cout << "Enter command number (21 for menu): " ;
		cin >> read;


	}

    }





void LoadTrack(TrackList CW[], TrackList CC[]){



	CW[0].Add(2,1,STRAIGHT);
	CW[1].Add(2,1,CURVED);
	CW[2].Add(7,-1,NOTURNOUT);
	CW[3].Add(1,0,STRAIGHT);
	CW[4].Add(12,6,STRAIGHT);
	CW[4].Add(12,6,CURVED);
	CW[5].Add(4,-1,NOTURNOUT);
//	CW[6].Add(12,-1,NOTURNOUT);
	CW[7].Add(15,2,STRAIGHT);
	CW[8].Add(0,-1,NOTURNOUT);
	CW[9].Add(3,-1,NOTURNOUT);
//	CW[10].Add(-1,-1,NOTURNOUT);
	CW[11].Add(5,6,CURVED);
	CW[11].Add(5,6,STRAIGHT);
	CW[12].Add(15,2,CURVED);
	CW[13].Add(8,4,STRAIGHT);
	CW[13].Add(9,4,CURVED);
	CW[14].Add(11,-1,NOTURNOUT);
	CW[15].Add(13,3,STRAIGHT);
	CW[15].Add(14,3,CURVED);


	CC[0].Add(8,-1,NOTURNOUT);
	CC[1].Add(3,0,STRAIGHT);
	CC[2].Add(1,1,CURVED);
	CC[2].Add(0,1,STRAIGHT);
	CC[3].Add(9,-1,NOTURNOUT);
	CC[4].Add(5,-1,NOTURNOUT);
	CC[5].Add(11,6,STRAIGHT);
	CC[5].Add(11,6,CURVED);
//	CC[6].Add(5,-1,NOTURNOUT);
	CC[7].Add(2,-1,STRAIGHT);
	CC[8].Add(13,4,STRAIGHT);
	CC[9].Add(13,4,CURVED);
//	CC[10].Add(-1,-1,-1,NOTURNOUT);
	CC[11].Add(14,-1,NOTURNOUT);
	CC[12].Add(4,6,STRAIGHT);
	CC[12].Add(4,6,CURVED);
	CC[13].Add(15,3,STRAIGHT);
	CC[14].Add(15,3,CURVED);
	CC[15].Add(7,2,STRAIGHT);
	CC[15].Add(12,2,CURVED);



}


void PrintMenu(){


	cout << endl;
	cout << "-1:   to exit program" << endl;
	cout << "0-15: to signal that turnout has been covered" << endl;
	cout << "16:   to toggle a turnout" << endl;
	cout << "17:   to toggle the direction of a train" << endl;
	cout << "18:   to add a new train to the course" << endl;
	cout << "19:   to toggle the mode between BATCH and INTERACTIVE" << endl;
	cout << "20:   to print the turnout status" << endl;
	cout << "21:   for the menu" << endl;


}


void ToggleToStatus(int Turnouts[], int to){

	if (Turnouts[to] == STRAIGHT)
		Turnouts[to] = CURVED;
	else
		Turnouts[to] = STRAIGHT;


}

void PrintToStatus(int Turnouts[]){

	for (int i = 0; i < MAXTURNOUTS ;  i++)
		cout << "Turnout " << i << " is: " << Turnouts[i];


}



int Opposite(int Turnouts[], int to){

	if (Turnouts[to] == STRAIGHT)
		return CURVED;
	else
		return STRAIGHT;
	
}






	



  
