// copy.cpp
//*******************************************************
//
//   Purpose:  Copies source_file to dest_file.  Use path
//             names for different drives.
//   Example:  sourcefile: g:\prog5.txt
//             dest_file:  a:\prog5.txt
//
//   Note:    First use CD to change to the appropriate directories
//            or give the full path as the file name.
//********************************************************

#include <iostream>
#include <fstream>
#include "g:\cslib\stringfix"
using namespace std;

int main()
{
  const char nwln = '\n';
  char ch;  int cnt;
  string source_file, dest_file;
  ifstream fin ;
  ofstream fout;
  
  cout << "Enter the source file name: " << flush; cin >> source_file;
  fin.open( source_file.c_str() ); 
  if ( fin.fail() ) {
   cerr << "error in opening input file\n";
   return 1; // return an error code to the OS
  }
 
  cout << "Enter the destination file name: " << flush; cin >> dest_file;
  fout.open( dest_file.c_str() );
  if ( fout.fail() ) {
     cerr << "error in opening output file\n";
     return 2; // return error code to the OS
  }

  cnt = 0;
  fin.get(ch);
  // fin.eof() will be false until you actually read the <eof>.
  while (!fin.eof()) {
       //process this line.
       while ( ch != nwln  &&  !fin.eof() )  {
	  cnt++;
	  fout.put(ch);
	  fin.get(ch);
       }
       // reached nwln or eof

       if (!fin.eof())  {
	  fout.put(nwln);
	  cnt++;
	  fin.get(ch);  //first char of next line
	}
  }
  //reached eof
  fin.close();  fout.close();
  cout << cnt << " characters copied." << endl;
  return 0;  // return an ok to the OS.
}
